uses putshape;
const
  b256x:byte=$7;
  b256y:byte=$6;
  mx:byte =3;
  my:byte=4;
  maxh:word=5;
var
  f,mf,sf:file;
  u,a,b,i,j,k,z,r:word;
  chunkbuf:array[0..$f,0..$f] of word;
  c:char;
  ltbl:array[0..$3f,0..$3f] of word;
  mtbl:array[0..$ff] of word;
  stbl:array[0..$2fff] of byte;
  ssa,sl,st,stsn,stssn,stsx,stsy,stso:word;
procedure rdchunk(n:longint); {0..$bff}
begin
  seek(f,n*$200);
  blockread(f,chunkbuf,$200,r)
end;

procedure drchunk(x,y:word);
var
  t:word;
begin
  for i:=0 to $3f do
    for j:=0 to $3f do ltbl[j,i]:=$ffff;
  for i:=0 to 15 do
    for j:=0 to 15 do
      begin
        t:=chunkbuf[j,i] and $3ff;
        if t < $96 then
          prshp(t,(hi(chunkbuf[j,i]) shr 2) and $1f,x+i*8,y+j*8)
        else
            ltbl[j*2+$21-dtbl[t,1],i*2+$21-dtbl[t,0]]:=j*16+i;
      end;
  for a:=0 to $3f do
    for b:=0 to a do
      if ltbl[b,a-b]<>$ffff then
        begin
          j:=ltbl[b,a-b] div 16;
          i:=ltbl[b,a-b] mod 16;
          prbshp(chunkbuf[j,i] and $3ff,(hi(chunkbuf[j,i]) shr 2) and $1f,x+i*8,y+j*8)
      end;
  for a:=$40 to $7f do
    for b:=a-$3f to $3f do
      if ltbl[b,a-b]<>$ffff then
        begin
          j:=ltbl[b,a-b] div 16;
          i:=ltbl[b,a-b] mod 16;
          prbshp(chunkbuf[j,i] and $3ff,(hi(chunkbuf[j,i]) shr 2) and $1f,x+i*8,y+j*8)
      end;
end;

procedure drstbl(x,y:word);
begin
  ssa:=stbl[$80+(b256x+b256y*16)*8]+stbl[$81+(b256x+b256y*16)*8]*256;
  gotoxy(16,24);
  writehex(ssa,4);
  sl:=(stbl[$84+(b256x+b256y*16)*8]+stbl[$85+(b256x+b256y*16)*8]*256) div 4;
  ssa:=ssa+4*(sl)-4;
  for st:=1 to sl do
    begin
      stso:=stbl[ssa+1];
      if stso<maxh then
      begin
        stsn:=(stbl[ssa+2]+stbl[ssa+3]*256) and $3ff;
        stssn:=(stbl[ssa+3] shr 2) and $1f;
        stsy:=stbl[ssa] and $f;
        stsx:=stbl[ssa] shr 4;
        if stsn<$96 then
          prshp(stsn,stssn,x+stsx*8,y+stsy*8)
        else
          prbshp(stsn,stssn,x+stsx*8-stso*4,y+stsy*8-stso*4)
      end;
        ssa:=ssa-4
    end
end;

procedure readmap;
begin
  seek(mf,longint(mx+my*12)*$200);
  blockread(mf,mtbl,512,r);
  assign(sf,u7path+'u7ifix'+hexstr[(mx+my*12) div 16]+hexstr[(mx+my*12) mod 16]);
  reset(sf,1);
  blockread(sf,stbl,$3000,r);
  close(sf)
end;
begin
  assign(mf,u7path+'u7map');
  reset(mf,1);
  readmap;
  assign(f,u7path+'u7chunks');
  reset(f,1);
  grinit;
  repeat
    rdchunk(mtbl[b256x+b256y*16]);
    cls;
    drchunk(128,68);
    drstbl(128,68);
    gotoxy(0,24);
    writehex(k,3);
    gotoxy(4,24);
    writehex(mx,2);
    gotoxy(7,24);
    writehex(b256x,2);
    gotoxy(10,24);
    writehex(my,2);
    gotoxy(13,24);
    writehex(b256y,2);
    repeat until keypressed;
    c:=readkey;
    case c of
      '0'..'9': maxh:=(byte(c)-byte('0'))*5;
      'i': begin
             b256y:=b256y-1;
             if b256y=255 then
             begin
               b256y:=15;
               c:='w'
             end
           end;
      'j': begin
             b256x:=b256x-1;
             if b256x=255 then
             begin
               b256x:=15;
               c:='a'
             end
           end;
      'k': begin
             b256y:=b256y+1;
             if b256y=16 then
             begin
               b256y:=0;
               c:='s'
             end
           end;
      'l': begin
             b256x:=b256x+1;
             if b256x=16 then
             begin
               b256x:=0;
               c:='d'
             end
           end;
      'w': begin
             my:=my-1;
             if my=255 then my:=11;
             c:=' ';
             readmap
           end;
      'a': begin
             mx:=mx-1;
             if mx=255 then mx:=11;
             c:=' ';
             readmap
           end;
      's': begin
             my:=my+1;
             if my=12 then my:=0;
             c:=' ';
             readmap
           end;
      'd': begin
             mx:=mx+1;
             if mx=12 then mx:=0;
             c:=' ';
             readmap
           end
    end;
    case c of
      'w': begin
             my:=my-1;
             if my=255 then my:=11;
             c:=' ';
             readmap
           end;
      'a': begin
             mx:=mx-1;
             if mx=255 then mx:=11;
             c:=' ';
             readmap
           end;
      's': begin
             my:=my+1;
             if my=12 then my:=0;
             c:=' ';
             readmap
           end;
      'd': begin
             mx:=mx+1;
             if mx=12 then mx:=0;
             c:=' ';
             readmap
           end
    end;
  until c=#27;
  close(mf);
end.
