unit PutShape;

interface

uses dos;

const
  u7path = 'c:\games\serpent\static\';  { STATIC\ Directory          }
  pspath = '';                          { MINI.FNT Directory         }
  msn = $40b;                           { Part1 = $3FF, Part2 = $40b }

  bgc:byte = 0;
  fc:byte = $f;
  HexStr: Array[0..$F] of Char = '0123456789ABCDEF';
  wherex:byte=0;
  wherey:byte=0;
type
  ShpNameType = Array[0..$40f] of String[25];
var
  ShpName: ^ShpNameType;
  smax:array[0..$40f] of byte;

procedure prshp(sn,ssn,x,y:word);
procedure prbshp(sn,ssn,x,y:word);
function keypressed:boolean;
function readkey:char;
procedure grinit;
procedure cls;
procedure gotoxy(x,y:byte);
procedure putch(c:char);
procedure WriteCh(Ch: Char);
procedure WriteStr(S: String);
procedure WriteInt(I: LongInt; W: Byte);
procedure WriteReal(R: Real; W, D: Byte);
procedure writehex(h:longint; w:byte);

implementation

type
  sbuftype = array[0..30,0..31,0..63] of byte;
  zbuftype = array[0..$fffe] of byte;
const
  sbtail:byte = 0;
var
  regs:registers;
  f: file;
  abuf:array[0..$81f] of longint;
  pbuf:array[0..$2ff] of byte;
  sbuf:^sbuftype;
  zbuf:^zbuftype;
  efnt:array[0..511] of byte;
  i:byte;
  r,zbindex:word;
  sbindex:array[0..30] of word;
  exitsave:pointer;
  scraddr,tmp:word;
  tc:char;
function getshp(sn:word):pointer; {0..$95 only}
begin
  i:=255;
  repeat
  inc(i)
  until (i=30) or (sbindex[i]=sn);
  if sbindex[i]<>sn then
  begin
    i:=sbtail;
    sbtail:=(sbtail+1) mod 31;
    tmp:=abuf[sn*2+1];
    smax[sn]:=tmp div 64;
    seek(f,abuf[sn*2]);
    sbindex[i]:=sn;
    blockread(f,sbuf^[i],2048,r)
  end;
  getshp:=addr(sbuf^[i])
end;

procedure prshp(sn,ssn,x,y:word); { $96.. }
var
  shpaddr:pointer;
  tx,ty:word;
begin
  if sn<$96 then
  begin
    shpaddr:=getshp(sn);
    if ssn>=smax[sn] then exit;
    asm
        push    ds
        mov     ax,x
        mov     bx,y
        add     ah,bl
        xchg    bh,bl
        shr     bx,1
        shr     bx,1
        add     ax,bx
        mov     scraddr,ax
        mov     bx,ssn
        xchg    bh,bl
        shr     bx,1
        shr     bx,1
        mov     di,scraddr
        lds     si,shpaddr
        add     si,bx
        mov     ax,$a000
        mov     es,ax
        mov     bx,8
@ps1:   mov     cx,4
        rep movsw
        add     di,312
        dec     bx
        jnz     @ps1
        pop     ds
    end
  end
end;

procedure prbshp(sn,ssn,x,y:word);
var
  shpaddr:pointer;
begin
  if sn>$95 then
    begin
      if zbindex<>sn then
      begin
        seek(f,abuf[sn*2]);
        blockread(f,zbuf^,abuf[sn*2+1],r);
        smax[sn]:=(zbuf^[4] shr 2)-1;
        zbindex:=sn
      end;
      if ssn<smax[sn] then
        begin
          shpaddr:=addr(zbuf^);
        asm
        push    ds
        mov     ax,$a000
        mov     es,ax
        lds     si,shpaddr
        mov     ax,ssn
        inc     ax
        shl     ax,1
        shl     ax,1
        add     si,ax
        mov     si,ds:[si]
        add     si,8
@psnl:  lodsw
        mov     cx,ax
        lodsw
        add     ax,x
        add     ax,7
        mov     bx,ax
        lodsw
        add     ax,y
        add     ax,7
        cmp     ax,$200
        jae     @psxdr
        add     bh,al
        xchg    ah,al
        shr     ax,1
        shr     ax,1
        add     ax,bx
        mov     di,ax
        shr     cx,1
        jz      @psend
        jc      @psr1
        rep movsb
        jmp     @psnl
@psxdr: shr     cx,1
        jz      @psend
        jc      @psxd2
        add     si,cx
        jmp     @psnl
@psxd2: mov     bx,cx
        xor     ah,ah
@psxd3: lodsb
        shr     ax,1
        jnc     @psxd4
        inc     si
        sub     bx,ax
        jz      @psnl
        jmp     @psxd3
@psxd4: add     si,ax
        sub     bx,ax
        jz      @psnl
        jmp     @psxd3
@psr1:  mov     bx,cx
        xor     ah,ah
@psr2:  lodsb
        shr     ax,1
        jnc     @psr3
        sub     bx,ax
        mov     cx,ax
        lodsb
        rep stosb
        or      bx,bx
        jz      @psnl
        jmp     @psr2
@psr3:  sub     bx,ax
        mov     cx,ax
        rep movsb
        or      bx,bx
        jz      @psnl
        jmp     @psr2
@psend: pop     ds
        end
        end
    end
end;

function keypressed:boolean; assembler;
asm
        mov     ah,$b
        int     $21
        and     al,1
end;

function readkey:char; assembler;
asm
        mov     ah,7
        int     $21
end;

procedure grinit; assembler;
asm
        mov     ax,$13
        int     $10
        mov     ax,$1012
        xor     bx,bx
        mov     cx,$ff
        mov     dx,seg pbuf
        mov     es,dx
        mov     dx,offset pbuf
        int     $10
end;

procedure cls; assembler;
asm
        mov     ax,$a000
        mov     es,ax
        xor     di,di
        mov     cx,32000
        mov     ax,di
        rep stosw
end;

procedure gotoxy(x,y:byte);
begin
  wherex:=x;
  wherey:=y
end;

procedure putch(c:char);
begin
  asm
        mov     al,c
        mov     bl,wherex
        xor     bh,bh
        shl     bx,1
        shl     bx,1
        mov     dh,wherey
        xor     dl,dl
        shl     dx,1
        add     bx,dx
        shl     dx,1
        shl     dx,1
        add     bx,dx
        mov     ch,fc
        mov     cl,bgc
	mov	di,bx
	xor	ah,ah
	shl	ax,1
	shl	ax,1
	add	ax,offset efnt
	push	ds
	mov	si,seg efnt
	mov	ds,si
	mov	si,ax
        mov     ax,$a000
        mov     es,ax
	mov	dl,4
@putch1:	mov	dh,8
	lodsb
@putch4:	shr	al,1
	jnc	@putch2
	mov	byte ptr es:di,ch
	jmp	@putch3
@putch2:	mov	byte ptr es:di,cl
@putch3:	add	di,320
	dec	dh
	jnz	@putch4
	sub	di,2559
	dec	dx
	jnz	@putch1
	pop	ds
  end;
  if wherex < 79 then inc(wherex)
end;

procedure WriteCh(Ch: Char);
begin
  if Byte(Ch) in [7..10, 13] then
  begin
    case Byte(Ch) of
      7: Write(#7);
      8: if WhereX > 0 then Dec(WhereX);
      9: begin
           WhereX := (WhereX div 8 + 1) * 8;
           if WhereX > 79 then
             begin
               WhereX := 0;
               if WhereY < 24 then
                 Inc(WhereY)
             end
	 end;
     10: if WhereY < 79 then
          Inc(WhereY);
     13: WhereX := 0;
    end;
  end
  else
    putch(ch)
end;


procedure WriteStr(S: String);
var
  C: Byte;
begin
  if S[0] > #0 then
    for C := 1 to Byte(S[0]) do
      WriteCh(S[C])
end;

procedure WriteInt(I: LongInt; W: Byte);
var
  S: String;
begin
  Str(I: W, S);
  WriteStr(S)
end;

procedure WriteReal(R: Real; W, D: Byte);
var
  S: String;
begin
  Str(R: W: D, S);
  WriteStr(S)
end;

procedure writehex(h:longint; w:byte);
var
  s:string;
begin
  s[0]:=chr(w);
  for i:=w downto 1 do
    begin
      s[i]:=hexstr[h mod 16];
      h:=h div 16
    end;
  writestr(s)
end;

procedure myexitproc; far;
begin
  exitproc:=exitsave;
  close(f);
  regs.ax := $3;
  intr($10,regs)
end;

begin
  exitsave:=exitproc;
  exitproc:=@myexitproc;
  for i:=0 to 30 do sbindex[i]:=$ffff;
  zbindex:=0;
  New(ShpName);
  New(sbuf);
  New(zbuf);
  assign(f,u7path+'text.flx');
  reset(f,1);
  seek(f,$80);
  blockread(f,abuf,$2060,r);
  for zbindex:=0 to 1035 do
  begin
    seek(f,abuf[zbindex*2]);
    i:=ord(chr(abuf[zbindex*2+1]))-1;
    shpname^[zbindex][0]:=chr(i);
    blockread(f,shpname^[zbindex][1],25,r)
  end;
  close(f);
  assign(f,u7path+'palettes.flx');
  reset(f,1);
  seek(f,$100+(0*$300));   {Select Palette Table}
  blockread(f,pbuf,$300,r);
  close(f);
  assign(f,pspath+'mini.fnt');
  reset(f,1);
  blockread(f,efnt,512,r);
  close(f);
  assign(f,u7path+'shapes.vga');
  reset(f,1);
  seek(f,$80);
  blockread(f,abuf,$2060,r);
end.