const
  HexStr: Array[0..$F] of Char = '0123456789ABCDEF';

var
  f1,f2:file;
  fn,hdr,ext,temp:string;
  ofs:word;
  num,addr,size,ts:longint;
  r:word;
  t:byte;
  abuf:array[0..6144] of longint;
  dbuf:array[0..32767] of byte;

procedure quit;
begin
  close(f1);
  close(f2);
  writeln(#7+'!!! DiskFull !!!');
  halt(0)
end;

begin
  write('Input Filename : ');
  readln(fn);
  write('Output File Header : ');
  readln(hdr);
  write('Output File Extension : ');
  readln(ext);
  write('Offset(HEX: Most case 80 or A0) : ');
  readln(temp);
  ofs:=0;
  for t := 1 to byte(temp[0]) do
    ofs:=ofs*16+ord(upcase(temp[t]))-48-byte(temp[t]>'@')*7;
  assign(f1,fn);
  reset(f1,1);
  seek(f1,ofs);
  blockread(f1,abuf,24576,r);
  ts := ((abuf[0]-ofs) div 8)-1;
  ofs:=0;
  for num:=0 to ts do
  begin
    if (abuf[ofs]<>0) and (abuf[ofs]<10000000) then
    begin
      assign(f2,hdr+hexstr[num div 4096]+hexstr[(num div 256) mod 16]
                   +hexstr[(num div 16) mod 16]+hexstr[num mod 16]+'.'+ext);
      rewrite(f2,1);
      seek(f1,abuf[ofs]);
      size:=abuf[ofs+1];
      repeat
        if size>32768 then
        begin
          size:=size-32768;
          blockread(f1,dbuf,32768,r);
          blockwrite(f2,dbuf,32768,r);
          if r < 32768 then quit;
        end
        else
        begin
          blockread(f1,dbuf,size,r);
          blockwrite(f2,dbuf,size,r);
          if r < size then quit;
          size:=0;
          close(f2)
        end
      until size = 0
    end;
    ofs:=ofs+2
  end;
  close(f1)
end.
